PPWGroupProject/urls.py
from django.contrib import admin
from django.urls import path, include
from support import views as support
from feedback import views as feedback_views
from kuesioner import views as kuesioner
from articles import views as articles
from authen import views as authen
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('duar.urls')),
    path('formulirsupport/', support.formulir_support, name = 'formulirsupport'),
    path('landingsupport/', support.landingsupport, name = 'landingsupport'),
    path('support/', support.support, name = 'support'),
    path('AjaxSupportDetail/', support.ajax_support, name = 'ajaxsupport'),
    path('supportJSONData/', support.manage_JSON, name='supportJSONData'),

    path('articles/', articles.articles_page, name = 'articles'),
    path('insertarticles/', articles.insert_articles, name = 'insertarticles'),
    path('insertAjaxArticles/', articles.ajax_articles, name = 'ajax_articles'),
    path('articles/<str:pk>', articles.selengkapnya, name = 'selengkapnya'),
    path('deletearticle/<str:pk>', articles.hapus_artikel, name = 'hapus_artikel'),
    path('articlesAPI/', articles.json_req, name='artikel_json'),

    path('feedback/', feedback_views.feedback, name = 'feedback'),

    path('login/', authen.login_page, name='login_page'),
    path('register/', authen.register_page, name='register_page'),
    path('logout/', authen.logout_page, name='logout_page'),

    path('kuesioner/', kuesioner.formulir_kuesioner, name = 'kuesioner'),
    path('listkuesioner/', kuesioner.list_kuesioner, name = 'listkuesioner'),
    path('hasilkuesioner/<str:pk>/', kuesioner.hasil_kuesioner, name = 'hasilkuesioner'),
    path('jsonkuesioner/', kuesioner.query_kuesioner, name='query_kuesioner')
]

urlpatterns += static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

articles/urls.py
from django.urls import path

from . import views

app_name = 'articles'

urlpatterns = [
]

duar/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('contact/', views.contact, name='contact')
]

articles/models.py
import datetime
from django.db import models
from datetime import datetime, date, time

KATEGORI_CHOICES = (
    ('Umum', 'Umum'),
    ('Kesehatan', 'Kesehatan'),
    ('Teknologi', 'Teknologi'),
    ('Politik', 'Politik'),
    ('Ekonomi', 'Ekonomi'),
    ('Sosial', 'Sosial'),
    ('Pendidikan', 'Pendidikan'),
    ('Makanan', 'Makanan'),
    ('Alam', 'Alam'),
)

# Create your models here.
class Articles(models.Model):
    penulis = models.CharField(max_length=20, null=True)
    kategori = models.CharField(max_length=20, choices=KATEGORI_CHOICES, default='Umum')
    tanggal = models.DateField()
    judul = models.CharField(max_length=100)
    isi_artikel = models.TextField(max_length=1000)
    gambar_artikel = models.ImageField(default="virusbiru2.svg")


    def seralize(self):
        tanggal1 = self.tanggal.strftime("%B")
        tanggal2 = self.tanggal.strftime("%d, %Y")
        tanggal_potong = tanggal1[0:3]
        arg =  {
            'penulis' : self.penulis,
            'kategori' : self.kategori,
            'tanggal' : tanggal_potong + ". " + tanggal2,
            'judul' : self.judul,
            'isi_artikel' : self.isi_artikel,
            'gambar_artikel' : self.gambar_artikel.url,
            'pk' : self.pk
        }

        return arg

    def __str__(self):
        return self.judul

articles/forms.py
from django import forms
from django.forms import ModelForm, Textarea, TextInput, DateInput
from .models import Articles
from crispy_forms.helper import FormHelper
from django.contrib.admin.widgets import AdminDateWidget


KATEGORI_CHOICES = (
    ('Umum', 'Umum'),
    ('Kesehatan', 'Kesehatan'),
    ('Teknologi', 'Teknologi'),
    ('Politik', 'Politik'),
    ('Ekonomi', 'Ekonomi'),
    ('Sosial', 'Sosial'),
    ('Pendidikan', 'Pendidikan'),
    ('Makanan', 'Makanan'),
    ('Alam', 'Alam'),
)

class ArticlesForm(ModelForm):
    def __init__(self, *args, **kwargs):
        super(ArticlesForm, self).__init__(*args, **kwargs)
        self.helper = FormHelper()
        # self.fields['penulis'].label = 'Penulis'
        self.fields['kategori'].label = 'Kategori'
        self.fields['tanggal'].label = 'Tanggal'
        self.fields['judul'].label = 'Judul'
        self.fields['isi_artikel'] = forms.CharField(widget=forms.Textarea, min_length=300, max_length=1000)
        self.fields['isi_artikel'].label = 'Isi Artikel'
        self.fields['gambar_artikel'].label = 'Gambar Artikel'

    class Meta:
        model = Articles
        fields = ['penulis', 'kategori', 'tanggal', 'judul', 'isi_artikel', 'gambar_artikel']
        widgets = {'penulis': forms.HiddenInput()}

articles/views.py
from django.shortcuts import render, redirect
from .models import Articles
from .forms import ArticlesForm
from django.http import HttpResponse
from django.http import JsonResponse
from django.core import serializers
from django.http import HttpResponse
from django.contrib.auth.models import Permission, User
import json
from django.core.serializers.json import DjangoJSONEncoder


from django.contrib.auth.decorators import login_required


# Create your views here.
def articles_page(request):
    semua_artikel = Articles.objects.all()
    jumlah_semua_artikel = semua_artikel.count()
    context = {'semua_artikel': semua_artikel, 'jumlah_semua_artikel': jumlah_semua_artikel}
    return render(request, 'articles.html', context)

@login_required(login_url='/login')
def insert_articles(request):
    if request.method == 'POST':
        # create a form instance and populate it with data from the request:
        form = ArticlesForm(request.POST, request.FILES)
        # check whether it's valid:
        if form.is_valid():
            form.save()
            return redirect('articles')
        # if a GET (or any other method) we'll create a blank form
    else:
        form = ArticlesForm(initial={ 'penulis' : request.user.username})
    return render(request, 'insertarticles.html', {'form': form})

def selengkapnya(request, pk):
    satu_artikel = Articles.objects.get(id = pk)
    return render(request, 'selengkapnya.html', {'satu_artikel': satu_artikel})

@login_required(login_url='/login')
def hapus_artikel(request, pk):
    satu_artikel = Articles.objects.get(id=pk)
    if request.user.username == satu_artikel.penulis:
        if request.method == "POST":
            satu_artikel.delete()
            return redirect("articles")
    else:
        return HttpResponse("Forbidden Query")

    context = {'satu_artikel': satu_artikel}
    return render(request, 'konfirmhapus.html', context)

@login_required(login_url='/login')
def ajax_articles(request):
    if request.method == "POST":
        kategori = request.POST['kategori']
        tanggal = request.POST['tanggal']
        judul = request.POST['judul']
        isi_artikel = request.POST['isi_artikel']
        gambar_artikel = request.FILES['gambar_artikel']
        Articles.objects.create(
            penulis = request.user.username,
            kategori = kategori,
            tanggal = tanggal,
            judul = judul,
            isi_artikel = isi_artikel,
            gambar_artikel = gambar_artikel,
        )

        return HttpResponse('')
    return render(request, 'insertarticlesAjax.html')

def json_req(request):
    serialized_articles = []
    all_articles = Articles.objects.all()
    username = request.user.username
    for article in all_articles:
      serialized_articles.append(article.seralize())
    serialized_articles.append({'username': username})
    return HttpResponse(json.dumps(serialized_articles, sort_keys=True, indent = 1, cls = DjangoJSONEncoder), content_type='application/json')

articles/templates/articles.html
{% extends 'base_articles.html' %}
{% load static %}
{% block cdnscript %}
{% endblock %}
{% block content %}
    <header class="container_judul">
        <a href="{% url "articles" %}" style="text-decoration: none">
        <h1 class="landing_judul">
            Semua Artikel
        </h1>
        </a>
        {% if user.is_authenticated %}
        <a href="{% url 'ajax_articles' %}">
            <img src="{% static 'image/plus 2.svg' %}" class="plus" alt="">
        </a>
        {% endif %}
    </header>
    {% if user.is_authenticated %}
    {% else %}
        <div class="no-login">
             <p>Silahkan login untuk menambahkan artikel</p>
        </div>
    {% endif %}

    <div class="btn_search_cont">
        <input id="keyword" placeholder="Masukan Judul Artikel" class="form-control">
        <button class="searchButton"> Cari Artikel</button>
        <button class="searchButton2"> <img src="{% static 'image/search.svg' %}" class="search_logo"></button>
    </div>

    <section class="container_articles">
        {% for artikel in semua_artikel  %}
        <div class="single_artikel">
            <div class="container_gambar">
                <img class = "gambar_artikel" src= "{{ artikel.gambar_artikel.url }}" alt="">
            </div>
            <div class="isi_artikel">
                <p class="judul_artikel">
                    {{ artikel.judul }}
                </p>
                <p class="isi_artikel">
                    {{ artikel.isi_artikel|truncatechars:130 }}
                </p>
            </div>

            <div class="hapus_dan_lanjutan">
                <form action="{% url 'selengkapnya' artikel.id %}" method="post">
                         {% csrf_token %}
                    <button type="submit" class="btn btn-info" id="btnselengkapnya">Selengkapnya</button>
                </form>
                {% if artikel.penulis == request.user.username %}
                    <a href="{% url 'hapus_artikel' artikel.id %}"><button type="button" class="btn btn-danger" id="btnHapusmain">Hapus Artikel</button></a>
                {% endif %}
                <button class="btn_kiri"> 🡸 </button>
                <button class="btn_kanan"> 🡺 </button>
            </div>

            <div class="tanggal_kategori">
                <p class="kategori">
                    Oleh <span style="color:red;"> {{ artikel.penulis }}</span>
                </p>
                <p class="tanggal_main">
                     🕐 {{ artikel.tanggal}}
                </p>
            </div>

        </div>
        {% endfor %}
    {% if jumlah_semua_artikel == 0 %}
        {% if user.is_authenticated %}
        <h1 class="tidak_ada_artikel">
            Wah belum ada artikel nih, tekan tombol + untuk menambahkan artikel...
        </h1>
        {% endif %}
    {% endif %}
    </section>
    <script src="{% static 'js/articles_js.js' %}"></script>
{% endblock %}

articles/templates/articlesAjax.html
{% extends 'base_articles.html' %}
{% load static %}
{% block cdnscript %}
{% endblock %}
{% block content %}
    <header class="container_judul">
        <a href="{% url "articles" %}" style="text-decoration: none">
        <h1 class="landing_judul">
            Semua Artikel
        </h1>
        </a>
        {% if user.is_authenticated %}
        <a href="{% url 'ajax_articles' %}">
            <img src="{% static 'image/plus 2.svg' %}" class="plus" alt="">
        </a>
        {% endif %}
    </header>
    {% if user.is_authenticated %}
    {% else %}
        <div class="no-login">
             <p>Silahkan login untuk menambahkan artikel</p>
        </div>
    {% endif %}

    <div class="btn_search_cont">
        <input id="keyword" placeholder="Masukan Judul Artikel" class="form-control">
        <button class="searchButton"> Cari Artikel</button>
        <button class="searchButton2"> <img src="{% static 'image/search.svg' %}" class="search_logo"></button>
    </div>

    <section class="container_articles">
    </section>

    {% if jumlah_semua_artikel == 0 %}
        {% if user.is_authenticated %}
        <h1 class="tidak_ada_artikel">
            Wah belum ada artikel nih, tekan tombol + untuk menambahkan artikel...
        </h1>
        {% endif %}
    {% endif %}
    <script src="{% static 'js/articles_js.js' %}"></script>
{% endblock %}

articles/templates/base_articles.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- jQuery -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

     <!-- Logo -->
    <link rel="icon" href="{% static "image/logo.svg" %}">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">

    <!-- My CSS-->
    <link rel="stylesheet" href="{% static 'css/articles.css' %}">

{#    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>#}

    <!-- Bootstrap JS -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>

    <!-- Fengyuan Chen's Datepicker -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/datepicker/0.6.5/datepicker.min.css" integrity="sha256-b88RdwbRJEzRx95nCuuva+hO5ExvXXnpX+78h8DjyOE=" crossorigin="anonymous" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/datepicker/0.6.5/datepicker.min.js" integrity="sha256-/7FLTdzP6CfC1VBAj/rsp3Rinuuu9leMRGd354hvk0k=" crossorigin="anonymous"></script>

    <title>Articles</title>
</head>
<body>
    <nav class="navbar navbar-expand-xl navbar-light bg-transparent">
        <a class="navbar-brand" href="{% url 'index' %}">DUAR</a>
        <button class="navbar-dark navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav">
          <span class="navbar-dark navbar-toggler-icon"></span>
        </button>
        <div class="navbar-collapse collapse" id="navbarNav">
          <ul class="navbar-nav">
            <li class="nav-item">
              <a class="nav-link" href="{% url 'kuesioner' %}">Assesment</a>
            </li>
            <li class="nav-item">
              <a class="nav-link" href="{% url "articles" %}">Articles</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="{% url 'support' %}">Support</a>
              </li>
            <li class="nav-item">
                <a class="nav-link" href="{% url "feedback" %}">Feedback</a>
              </li>
             <li class="nav-item">
                <a class="nav-link" href="{% url "contact" %}">Contact</a>
              </li>
              {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout_page' %}"><button class="btn-logout">Logout</button></a>
                    </li>
              {% else %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'login_page' %}"><button class="btn-logout">Login</button></a>
                    </li>
              {% endif %}
          </ul>
        </div>
      </nav>
    {% block content %}
    {% endblock %}
{#<script src="{% static 'js/articles_js.js' %}"></script>#}
</body>
</html>

articles/templates/insertarticles.html
{% extends "base_articles.html" %}
{% load static %}
{% load crispy_forms_tags %}
{% block content %}
    <header class="container_judul">
        <h1 class="landing_judul">
            Tambahkan Artikel
        </h1>
    </header>
    <section class="container_form">
        <form action="" method="post" enctype="multipart/form-data" id="formUtama">
              {% csrf_token %}
              {{ form|crispy }}
             <input type="submit" value="Submit" class="btn btn-primary" id="submitButton" />
        </form>
    </section>
    <script>
        $(function () {
          $("#id_tanggal").datepicker({
          format:'yyyy-mm-dd',
        });
        });
    </script>
{% endblock %}

articles/templates/insertarticlesAjax.html
{% extends 'base_articles.html' %}


{% block content %}
     <header class="container_judul">
        <h1 class="landing_judul">
            Tambahkan Artikel
        </h1>
    </header>
     <section class="container_form">
        <form id="formUtama" method="post" enctype="multipart/form-data">
            {% csrf_token %}
            <input type="hidden" name="penulis" id="id_penulis">

            <div id="div_id_kategori" class="form-group">
                <label for="id_kategori" class=" requiredField"> Kategori<span class="asteriskField">*</span></label>
                <div class=""> <select name="kategori" class="select form-control" id="id_kategori">
                    <option value="Umum" selected="">Umum</option>
                    <option value="Kesehatan">Kesehatan</option>
                    <option value="Teknologi">Teknologi</option>
                    <option value="Politik">Politik</option>
                    <option value="Ekonomi">Ekonomi</option>
                    <option value="Sosial">Sosial</option>
                    <option value="Pendidikan">Pendidikan</option>
                    <option value="Makanan">Makanan</option>
                    <option value="Alam">Alam</option>
                </select>
                </div>
            </div>

            <div id="div_id_tanggal" class="form-group"> <label for="id_tanggal" class=" requiredField">
                Tanggal<span class="asteriskField">*</span> </label> <div class=""> <input type="text" name="tanggal" class="dateinput form-control" required="" id="id_tanggal"> </div> </div>

            <div id="div_id_judul" class="form-group"> <label for="id_judul" class=" requiredField">
                Judul<span class="asteriskField">*</span> </label> <div class=""> <input type="text" name="judul" maxlength="75" class="textinput textInput form-control" required="" id="id_judul"> </div> </div>

            <div id="div_id_isi_artikel" class="form-group"> <label for="id_isi_artikel" class=" requiredField">
                Isi Artikel<span class="asteriskField">*</span> </label> <div class=""> <textarea name="isi_artikel" cols="40" rows="10" maxlength="1000" minlength="300" class="textarea form-control" required="" id="id_isi_artikel"></textarea> </div> </div>

            <div id="div_id_gambar_artikel" class="form-group"> <label for="id_gambar_artikel" class=" requiredField">
                Gambar Artikel<span class="asteriskField">*</span> </label> <div class=""> <input type="file" name="gambar_artikel" accept="image/*" class="clearablefileinput form-control-file" required="" id="id_gambar_artikel"> </div> </div>

             <input type="submit" value="Submit" class="btn btn-primary" id="submitButton" />

        </form>
     </section>


    <script type="text/javascript">
        $(document).on("submit" , "#formUtama", function (e) {
            e.preventDefault();
            var formutama2 = document.getElementById("formUtama");
            var formData = new FormData(formutama2);
            $.ajax({
                type: 'POST',
                url: '/insertAjaxArticles/',
                data: formData,
                success:function () {
                        $(".container_form").append(
                            "<div class='alert'>" + "<span class=\"closebtn\" onclick=\"this.parentElement.style.display='none';\">&times;</span>\n" +
                            "Artikel berhasil ditambahkan" + "</div>"
                        );
                    $('#formUtama').trigger('reset');
                },
                cache: false,
                contentType: false,
                processData: false,
            });
        });
    </script>

     <script>
        $(function () {
          $("#id_tanggal").datepicker({
          format:'yyyy-mm-dd',
        });
        });
    </script>
{% endblock %}

articles/templates/konfirmhapus.html
{% extends 'base_articles.html' %}
{% block content %}

<header class="container_judul">
        <h1 class="landing_judul">
            Apakah anda yakin ingin menghapus artikel ini?
        </h1>
</header>

<section class="container_konfirmasi">
     <a href="{% url 'articles' %}"><button type="button" class="btn btn-info btn-lg" id="btntidak">Tidak</button></a>
    <form action="{% url 'hapus_artikel' satu_artikel.id %}" method="POST">
                {% csrf_token %}
            <button type="submit" class="btn btn-danger btn-lg" id="btnyakin" >Yakin</button>
    </form>
</section>

{% endblock %}

articles/templates/selengkapnya.html
{% extends 'base_articles.html' %}
{% load static %}
{% block cdnscript %}
{% endblock %}
{% block content %}
    <section class="wrapper_sel">
    <section class="main_selengkapnya">
    <header class="container_satu_judul">
        <h1 class="sebuah_judul_artikel">
            {{ satu_artikel.judul }}
        </h1>
    </header>

    <div class="container_tanggal_sub">
        <p class="tanggal_sub">Ditulis oleh {{satu_artikel.penulis}} &nbsp; &nbsp; &nbsp; &nbsp; {{ satu_artikel.tanggal }} &nbsp; &nbsp; &nbsp; &nbsp; {{ satu_artikel.kategori }}</p>
    </div>
    <div class="container_isi_artikel">
        <div class="container_satu_gambar">
            <img class = "gambar_artikel_sub" src= "{{ satu_artikel.gambar_artikel.url }}" alt="">
        </div>

        <p class="isi_artikel_sub">
            {{ satu_artikel.isi_artikel }}
        </p>

    </div>
    </section>
    </section>

{% endblock %}

articles/templates/testing.html
<!doctype html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>Static Example</title>
  <style>body {font-family: Arial, sans-serif;}</style>

</head>
<body>

  <input id="datepicker">
  {{ form.tanggal }}
  <script>
    $(function () {
      $("#datepicker").datepicker();
    });
  </script>


  <!-- jQuery -->
  <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>

  <!-- Fengyuan Chen's Datepicker -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/datepicker/0.6.5/datepicker.min.css" integrity="sha256-b88RdwbRJEzRx95nCuuva+hO5ExvXXnpX+78h8DjyOE=" crossorigin="anonymous" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/datepicker/0.6.5/datepicker.min.js" integrity="sha256-/7FLTdzP6CfC1VBAj/rsp3Rinuuu9leMRGd354hvk0k=" crossorigin="anonymous"></script>

</body>
</html>